// This is the header for the circle class.  The point of this project
// is not to do anything impressive, just to see if I can get used to the
// syntax of C++ workings again.  Yes, I'm a Java ho.  I will use java
// spacing conventions.  If you don't like that, cope with it.

#ifndef CIRCLE_H
#define CIRCLE_H

#define ZOMBIE 0
#define ORBIT 1

static BITMAP *orbitBitmap;
static BITMAP *zombieBitmap;
static int INITIALIZED = 0;

class Circle
{
      public:
             Circle(int _AI, int _X, int _Y, int _size, int _XVel, int _YVel); 
             int getLeft();         // The left bound of the circle
             int getRight();        // The right bound of the circle
             int getTop();          // The upper bound of the circle
             int getBottom();       // The lower bound of the circle
             void display();        // Outputs information about it
             void update();         // Calculates the new place of the circle
             void lean(int x, int y);          // Accelerates the circle towards the point given
             void draw(BITMAP *bmp);           // Draws the circle on the specified bmp
             void collide(int dir);            // 0 = X, 1 = Y
             int testCollide(int, int, int);   // Test collision with another circle, and collide
                                               // if they overlap.
      private:
              int AIType;
              void initCircles();
              int itsX;
              int itsY;
              int itsSize;
              int itsXVel;
              int itsYVel;
              void initCircle(int AIType);     // Called by the constructors                                            
};

#endif
